GenAuth DocsDocuments
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Old version
Development Integration
  • API

  • SDK

    • Java

    • Node.js

    • Python

      • Installation and Usage
      • Authentication Module

      • Management Module

        • User Management

          • Get User List
          • Get User Information
          • Batch Get User Information
          • Create User
          • Batch Create Users
          • Update User Profile
          • Batch Update User Profile
          • Delete Users
          • Get User External Identity Sources
          • Get User Role List
          • Get User Real-name Authentication Info
          • Delete User Real-name Authentication Info
          • Get User Department List
          • Set User Departments
          • Get User Group List
          • Get User MFA Binding Info
          • Get Archived User List
          • Force Logout Users
          • Check if User Exists
          • Get User Accessible Apps
          • Get User Authorized Apps
          • Check if User Has Role
          • Get User Login History
          • Get User Previously Logged In Apps
          • Get User Previously Logged In Identity Sources
          • User Resignation
          • Batch User Resignation
          • Get User Authorized Resources
          • Check User Session Status in Application
          • Import User OTP
        • Organization Management

        • Role Management

        • User Group Management

        • Custom Field Management

        • Resource and Permission Management

        • 管理应用

        • 管理身份源

        • 管理安全配置

        • 管理消息服务

        • 管理 Pipeline

        • 管理 Webhook

        • 获取审计日志

        • 管理计量计费

        • 事件
  • Error Codes
  1. Development Integration
  2. /
  3. SDK
  4. /
  5. Python
  6. /
  7. Management Module

  8. /
  9. User Management

  10. /
  11. Get User List

¶ Get/search user list

Update time: 2025-07-23 07:34:21
Edit

This document is automatically generated based on https://github.com/authing/authing-docs-factory based on https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If this document description is incorrect, please refer to V3 API.

This interface is used to obtain user lists, supports fuzzy search, and filters users by user basic fields, user custom fields, user department, user history login application and other dimensions.

¶ Fuzzy search example

Fuzzy search will perform fuzzy search on users from five fields by default: phone, email, name, username, nickname. You can also set options.fuzzySearchOn to determine the range of fuzzy matching fields:

{
  "keywords": "xxxx",
  "options": {
    "fuzzySearchOn": ["address"]
  }
}

¶ Advanced search example

You can use advancedFilter to perform advanced search. Advanced search supports filtering users by basic information, custom data, department, user source, login application, external identity source information, etc. **These filtering conditions can be combined arbitrarily. **

¶ Filter users with disabled status

User status (status) is a string type, and the optional values ​​are Activated and Suspended:

{
  "advancedFilter": [
    {
      "field": "status",
      "operator": "EQUAL",
      "value": "Suspended"
    }
  ]
}

¶ Filter users whose mailboxes contain @example.com

User mailboxes (email) are string types and can be fuzzy searched:

{
  "advancedFilter": [
    {
      "field": "email",
      "operator": "CONTAINS",
      "value": "@example.com"
    }
  ]
}

¶ Search based on any extended fields of the user

{
  "advancedFilter": [
    {
      "field": "some-custom-key",
      "operator": "EQUAL",
      "value": "some-value"
    }
  ]
}

¶ Filter by number of user logins

Filter users with more than 10 logins:

{
  "advancedFilter": [
    {
      "field": "loginsCount",
      "operator": "GREATER",
      "value": 10
    }
  ]
}

Filter users with 10 to 100 login times:

{
  "advancedFilter": [
    {
      "field": "loginsCount",
      "operator": "BETWEEN",
      "value": [10, 100]
    }
  ]
}

¶ Filter based on the user's last login time

Filter users who have logged in within the last 7 days:

{
  "advancedFilter": [
    {
      "field": "lastLoginTime",
      "operator": "GREATER",
      "value": new Date(Date.now() - 7 * 24 * 60 * 60 * 1000)
    }
  ]
}

Filter users who have logged in within a certain period of time:

{
  "advancedFilter": [
    {
      "field": "lastLogin",
      "operator": "BETWEEN",
      "value": [
        Date.now() - 14 * 24 * 60 * 60 * 1000,
        Date.now() - 7 * 24 * 60 * 60 * 1000
      ]
    }
  ]
}

¶ Filter based on the applications that the user has logged in

Filter users who have logged in to applications appId1 or appId2:

{
  "advancedFilter": [
    {
      "field": "loggedInApps",
      "operator": "IN",
      "value": ["appId1", "appId2"]
    }
  ]
}

¶ Filter by user's department

{
  "advancedFilter": [
    {
      "field": "department",
      "operator": "IN",
      "value": [
        {
          "organizationCode": "steamory",
          "departmentId": "root",
          "departmentIdType": "department_id",
          "includeChildrenDepartments": true
        }
      ]
    }
  ]
}

¶ Method name

ManagementClient.list_users

¶ Request parameters

NameType
Required
Default value
Description
Sample value
keywordsstringNo-Fuzzy search keywordsxxx
advancedFilterListUsersAdvancedFilterItemDto[]No-Advanced search[{"field":"status","operator":"EQUAL","value":"Activated"}]
searchQueryobjectNo-Use ES query statements to execute search commands{"query":{"bool":{"must":[{"term":{"phone":"18818888888"}}],"must_not":[]}},"sort":["_score",{"created_at":"ASC"}]}
optionsListUsersOptionsDtoNo-Optional{"pagination":{"page":1,"limit":10},"fuzzySearchOn":["phone","email","name","username","nickname","identityNumber"],"withCustomData":true,"withIdentities":true,"withDepartmentIds":true}

¶ Request Response

Type: UserPaginatedRespDto

NameTypeDescription
statusCodenumberBusiness status code, which can be used to determine whether the operation is successful. 200 means success.
messagestringDescription
apiCodenumberSegmented error code, which can be used to get the specific error type (successful requests are not returned). For a detailed list of error codes, see: API Code List (opens new window)
requestIdstringRequest ID. Returned when the request fails.
dataUserPagingDtoResponse data

Example results:

{
  "statusCode": 200,
  "message": "Success",
  "requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
  "data": {
    "list": {
      "userId": "6229ffaxxxxxxxxcade3e3d9",
      "createdAt": "2022-07-03T03:20:30.000Z",
      "updatedAt": "2022-07-03T03:20:30.000Z",
      "status": "Activated",
      "workStatus": "Active",
      "externalId": "10010",
      "email": "test@example.com",
      "phone": "188xxxx8888",
      "phoneCountryCode": "+86",
      "username": "bob",
      "name": "xxx",
      "nickname": "xxx",
      "photo": "https://files.authing.co/authing-console/default-user-avatar.png",
      "loginsCount": 3,
      "lastLogin": "2022-07-03T03:20:30.000Z",
      "lastIp": "127.0.0.1",
      "gender": "M",
      "emailVerified": true,
      "phoneVerified": true,
      "passwordLastSetAt": "2022-07-03T03:20:30.000Z",
      "birthdate": "2022-06-03",
      "country": "CN",
      "province": "BJ",
      "city": "BJ",
      "address": "xxxxx",
      "streetAddress": "xxxxx",
      "postalCode": "438100",
      "company": "steamory",
      "browser": "Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0",
      "device": "iOS",
      "givenName": "xx",
      "familyName": "xxx",
      "middleName": "James",
      "profile": "alice",
      "preferredUsername": "alice",
      "website": "https://my-website.com",
      "zoneinfo": "GMT-08:00",
      "locale": "af",
      "formatted": "132, My Street, Kingston, New York 12401.",
      "region": "Xinjiang Uyghur Autonomous Region",
      "userSourceType": "register",
      "passwordSecurityLevel": 1,
      "departmentIds": "[\"624d930c3xxxx5c08dd4986e\",\"624d93102xxxx012f33cd2fe\"]",
      "identities": {
        "identityId": "62299d8b866d2dab79a89dc4",
        "extIdpId": "6076bacxxxxxxxxd80d993b5",
        "provider": "wechat",
        "type": "openid",
        "userIdInIdp": "oj7Nq05R-RRaqak0_YlMLnnIwsvg",
        "accessToken": "57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx",
        "refreshToken": "57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx",
        "originConnIds": "[\"605492ac41xxxxe0362f0707\"]"
      },
      "identityNumber": "420421xxxxxxxx1234",
      "customData": {
        "school": "xxxxx",
        "age": 22
      },
      "statusChangedAt": "2022-07-03T03:20:30.000Z"
    }
  }
}

¶ Data Structure

¶ ListUsersAdvancedFilterItemDto

NameType
Is this field required?
Description
Sample value
fieldstringyesUser fields specified for advanced search:
- id: User ID
- phone: Phone number
- email: Email address
- username: User name
- externalId: User ID in the external system
- name: Name
- status: User status, optional values ​​are Activated and Suspended
- gender: User gender, optional values ​​are M (male), F (female) and U (unknown)
- birthdate: Date of birth
- givenName: First name
- familyName: Last name
- preferredUsername: Preferred Username
- profile: Profile
- country: Country
- province: Province
- zoneinfo: Time zone
- website: personal website
- address: address
- streetAddress: street address
- company: company
- postalCode: postal code
- formatted: formatted address
- signedUp: registration time
- locale: language information
- lastLogin: last login time, as timestamp type
- loginsCount: number of logins, as numeric type
- lastLoginApp: last logged in application ID
- userSource: user source, see the example for specific usage
- department: user department, see the example for specific usage
- loggedInApps: applications that have been logged in, see the example for specific usage
- identity: user external identity source information, see the example for specific usage
- ... other custom fields
nickname
operatorstringIt is theoperator, and the optional values ​​are:
- EQUAL: is equal to, applicable to the matching of numbers and strings
- NOT_EQUAL: is not equal to, applicable to the matching of numbers and strings
- CONTAINS: the string contains
- NOT_CONTAINS: the string does not contain
- IS_NULL: is empty
- NOT_NULL: is not empty
- IN: is an element in an array
- GREATER: is greater than or equal to, applicable to the comparison of numbers and date type data
- LESSER: is less than or equal to, applicable to the comparison of numbers and date type data
- BETWEEN: is between something, applicable to the comparison of numbers and date type data
EQUAL
valueobjectNoSearch value, different field may correspond to different value types, see the example for details.test

¶ ListUsersOptionsDto

NameType
Is this field required?
Description
Sample value
paginationNoPagination configuration Nested type: PaginationDto.{"page":1,"limit":10}
sortarrayNoSorting settings, you can set multiple items to be sorted according to multiple fields Nested type: SortingDto.[{"field":"createdAt","direction":"desc"},{"field":"loginsCount","direction":"desc"}]
fuzzySearchOnarrayNoFuzzy search matching user fields, optional values ​​are:
- phone: user phone number, cannot contain phone number area code, included by default
- email: user email address, included by default
- name: user name, included by default
- username: user name, included by default
- nickname: user nickname, included by default
- id: user ID
- company: company
- givenName: first name
- familyName: last name
- middleName: middle name
- preferredUsername: Preferred Username
- profile: personal profile
- website: personal website
- address: address
- formatted: formatted address
- streetAddress: street address
- postalCode: postal code
withCustomDatabooleannoGet custom datatrue
withPostbooleannoGet department informationtrue
withIdentitiesbooleannoGet identitiestrue
withDepartmentIdsbooleannoGet department ID listtrue
flatCustomDatabooleanNoWhether to flatten the extended field

¶ PaginationDto

NameType
Required
Description
Sample value
pagenumberNoCurrent page number, starting from 11
limitnumberNoNumber per page, maximum cannot exceed 50, default is 1010

¶ SortingDto

NameType
Is this field required?
Description
Sample value
fieldstringyesThe field to be sorted. Optional values ​​are:
- createdAt: creation time
- updatedAt: modification time
- email: email address
- phone: phone number
- username: username
- externalId: external ID
- status: public account status
- statusChangedAt: status change time
- passwordLastSetAt: password change time
- loginsCount: number of logins
- gender: gender
- lastLogin: last login time
- userSourceType: public account registration source
- lastMfaTime: last MFA authentication time
- passwordSecurityLevel: password security level
- phoneCountryCode: Mobile phone area code
- lastIp: IP used for last login
createdAt
orderstringyesSorting order:
- desc: Sort by descending order from largest to smallest.
- asc: Sort by ascending order from smallest to largest.
desc

¶ UserPagingDto

NameType
Is it required?
Description
Sample value
totalCountnumberYesTotal number of records
listarrayYesData list Nested type: UserDto.

¶ UserDto

NameType
Is this field required?
Description
Sample value
userIdstringYesThe unique identifier of the user, which can be user ID, user name, email, phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id.6229ffaxxxxxxxxcade3e3d9
createdAtstringyescreation time2022-07-03T03:20:30.000Z
updatedAtstringyesupdate time2022-07-03T03:20:30.000Z
statusstringyescurrent status of the account:
- Activated: normal status
- Suspended: deactivated
- Deactivated: disabled
- Resigned: resigned
- Archived: archived
Suspended
workStatusstringyescurrent work status of the accountClosed
externalIdstringnothird-party external ID10010
emailstringnoemail address, case insensitivetest@example.com
phonestringNoPhone number without area code. If it is an international phone number, please specify the area code in the phoneCountryCode parameter.188xxxx8888
phoneCountryCodestringNoPhone area code. This parameter is optional for phone numbers in mainland China. The GenAuth SMS service does not currently support international phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes.+86
usernamestringNoUsername, unique in the user poolbob
namestringnoUser's real name, not uniquexxx
nicknamestringnoNicknamexxx
photostringnoAvatar linkhttps://files.authing.co/authing-console/default-user-avatar.png
loginsCountnumbernoTotal number of historical logins3
lastLoginstringnoLast login time2022-07-03T03:20:30.000Z
lastIpstringnoLast login IP127.0.0.1
genderstringyesGender:
- M: Male, male
- F: Female, female
- U: Unknown, unknown
M
emailVerifiedbooleanyesIs email verified?true
phoneVerifiedbooleanyesIs phone number verified?true
passwordLastSetAtstringNoUser's last password modification time2022-07-03T03:20:30.000Z
birthdatestringNoDate of birth2022-06-03
countrystringNoCountryCN
provincestringNoProvinceBJ
citystringNoCityBJ
addressstringNoAddressxxxxx
streetAddressstringNoStreet addressxxxxx
postalCodestringNoPostal code438100
companystringNoCompanysteamory
browserstringnoThe browser used when logging in lastMozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0
devicestringnoThe device used when logging in lastiOS
givenNamestringnoFirst Namexx
familyNamestringnoLast Namexxx
middleNamestringnoMiddle NameJames
profilestringnoPreferred Usernamealice
preferredUsernamestringnoPreferred Usernamealice
websitestringnoUser's personal websitehttps://my-website.com
zoneinfostringnoUser time zone informationGMT-08:00
localestringNoLocaleaf
formattedstringNoStandard full address132, My Street, Kingston, New York 12401.
regionstringNoUser's regionXinjiang Uyghur Autonomous Region
userSourceTypestringYesSource type:
- excel: Imported via excel
- register: User self-registration
- adminCreated: Manual creation by the administrator backend (including creating users using the management API)
- syncTask: Sync task in the sync center
excel
userSourceIdstringNoApplication ID or sync task ID
lastLoginAppstringNoApplication ID of the user's last login
mainDepartmentIdstringNoUser's main department ID
lastMfaTimestringNoThe last time the user performed MFA Certification time
passwordSecurityLevelnumberNoUser password security strength level1
resetPasswordOnNextLoginbooleanNoRequire password reset on next login
registerSourcearrayNoRegistration method
departmentIdsarrayNoUser department ID list["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"]
identitiesarrayNoExternal identity source Nested type: IdentityDto.
identityNumberstringNoUser ID number420421xxxxxxxx1234
customDataobjectNoUser's extended field data{"school":"xxxxx","age":22}
postIdListarrayNoUser-associated department ID
statusChangedAtstringNoUser status last modified time2022-07-03T03:20:30.000Z
tenantIdstringNoUser tenant ID

¶ IdentityDto

NameType
Is this field required?
Description
Sample value
identityIdstringyesIdentity source ID62299d8b866d2dab79a89dc4
extIdpIdstringyesIdentity source connection ID6076bacxxxxxxxxd80d993b5
providerstringyesExternal identity source type:
- wechat: WeChat
- qq: QQ
- wechatwork: WeChat for Business
- dingtalk: DingTalk
- weibo: Weibo
- github: GitHub
- alipay: Alipay
- baidu: Baidu
- lark: Feishu
- welink: Welink
- yidun: NetEase Yidun
- qingcloud: Qingyun
- google: Google
- gitlab: GitLab
- gitee: Gitee
- twitter: Twitter
- facebook: Facebook
- slack: Slack
- linkedin: Linkedin
- instagram: Instagram
- oidc: OIDC-based enterprise identity source
- oauth2: OAuth2-based enterprise identity source
- saml: SAML-based enterprise identity source
- ldap: LDAP-based enterprise identity source
- ad: AD-based enterprise identity source
- cas: CAS-based enterprise identity source
- azure-ad: Azure AD-based enterprise identity source
oidc
typestringYesIdentity type, such as unionid, openid, primaryopenid
userIdInIdpstringYesID in external identity sourceoj7Nq05R-RRaqak0_YlMLnnIwsvg
userInfoInIdpobjectYesUser's identity information in idp
accessTokenstringnoAccess Token in the external identity source (this parameter is returned only when the user actively obtains it, and it is not returned by the management interface).57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx
refreshTokenstringnoRefresh Token in the external identity source (this parameter is returned only when the user actively obtains it, and it is not returned by the management interface).57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx
originConnIdsarrayyesIdentity source connection ID list from which the identity comes["605492ac41xxxxe0362f0707"]
Previous article: Events Next article: Get User Information
  • Method name
  • Request parameters
  • Request Response
  • Data Structure

User identity management

Integrated third-party login
Customized authentication process

Enterprise internal management

Single sign-on
Multi-factor authentication
Permission management

Developer

Development Documentation
GitHub (opens new window)

Company

official@genauth.ai
16th Floor, Building B, Beichen Century Center, Chaoyang District, Beijing (Total)
Room 406, 4th Floor, Block B, No. 200, Tianfu Fifth Street, High-tech Zone, Chengdu (Branch)

© Beijing Steamory Technology Co., Ltd.